diff --git a/dput/dput.py b/dput/dput.py
index d21a6f7..688c163 100755
--- a/dput/dput.py
+++ b/dput/dput.py
@@ -341,6 +341,21 @@ def verify_files(
     changes = parse_changes(chg_fd)
     chg_fd.close
 
+    # Re  #884404 - Check for allowed distribution should be first
+    # Sorry, but this breaks the tests
+    distribution = changes.get('distribution')
+    allowed_distributions = config.get(host, 'allowed_distributions')
+    if distribution and allowed_distributions:
+        if debug:
+            sys.stdout.write(
+                    "D: Checking: distribution %s matches %s\n"
+                    % (distribution, allowed_distributions))
+        if not re.match(allowed_distributions, distribution):
+            raise dputhelper.DputUploadFatalException(
+                    "Error: uploading files for distribution %s to %s"
+                    " not allowed."
+                    % (distribution, host))
+
     # Find out if it's a binary only upload or not
     binary_upload = check_upload_variant(changes, debug)
 
@@ -433,19 +448,6 @@ def verify_files(
                     " Multiple uploads of the .tar.gz may be rejected by the\n"
                     "upload queue management software.\n")
 
-    distribution = changes.get('distribution')
-    allowed_distributions = config.get(host, 'allowed_distributions')
-    if distribution and allowed_distributions:
-        if debug:
-            sys.stdout.write(
-                    "D: Checking: distribution %s matches %s\n"
-                    % (distribution, allowed_distributions))
-        if not re.match(allowed_distributions, distribution):
-            raise dputhelper.DputUploadFatalException(
-                    "Error: uploading files for distribution %s to %s"
-                    " not allowed."
-                    % (distribution, host))
-
     if debug:
         sys.stdout.write("D: File to upload: %s\n" % change_file)
     files_to_upload.append(change_file)
